
package de.ivu.elect.presentation.wahlbeteiligung;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.wahlbeteiligung.boundary.WahlbeteiligungAuswertungConversationStore;
import de.ivu.elect.business.wahlbeteiligung.boundary.WahlbeteiligungAuswertungExtendedDAO;
import de.ivu.elect.business.wahlbeteiligung.boundary.WahlbeteiligungAuswertungEdit;
import de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertung;
import de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertungMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractWahlbeteiligungAuswertungEditNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractWahlbeteiligungAuswertungEditNoScopeView.VIEW_ID, useCase = UseCasePermission.WAHLBETEILIGUNG_AUSWERTUNG_EDIT)
public abstract class AbstractWahlbeteiligungAuswertungEditNoScopeView extends de.ivu.elect.presentation.AbstractElectEditView<WahlbeteiligungAuswertung>  {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wahlbeteiligungAuswertungEditView";

  public static final String VIEW_ID = "/wahlbeteiligung/wahlbeteiligung-auswertung-edit.xhtml";

  public static final String PARENT_VIEW_ID = "/wahlbeteiligung/wahlbeteiligung-auswertung-search.xhtml";

  @Inject
  protected transient WahlbeteiligungAuswertungExtendedDAO extendedDAO;

  @Inject
  protected transient WahlbeteiligungAuswertungEdit edit;

  @Inject
  @ConversationGroup(WahlbeteiligungAuswertungConversationStore.class)
  protected transient WahlbeteiligungAuswertungConversationStore conversationStore;

  @Inject
  protected transient WahlbeteiligungAuswertungMeta entityMeta;

  @Inject
  // ELECTDD-204 Auf doppelte Bearbeitung von Entitäten Hinweisen
  protected transient WahlbeteiligungAuswertungEditViewScopeStore entityViewStore;

  @de.ivu.elect.jee.faces.PreConditionCheck
  public String checkPreCondition() {
    if (getEntity() == null) {
      return getParentViewId();
    }
    return null;
  }

  @Override
  public WahlbeteiligungAuswertung getEntity() {
    if (conversationStore.getEntityPK() != null) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }
    return null;
  }

  public void setEntity(WahlbeteiligungAuswertung entity) {
    resetModel(); // DynaForm-Model zurücksetzen, damit die aktuelle Entität verwendte wird...
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  public boolean isEntitySet() {
    return conversationStore.getEntityPK() != null;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.WAHLBETEILIGUNG_AUSWERTUNG_DELETE)
  @Override
  public String delete() {
    return delete(getEntity());
  }

  protected String delete(WahlbeteiligungAuswertung entity) {
    edit.delete(entity);

    addMessageDeleteSuccess();

    resetStateAfterAction();
    return getParentViewId(); // definierter Parent, benutze deleteAndGoBack um zum vorherigen View zurückzukehren
  }



  @Redirect
  @UseCaseSecure(UseCasePermission.WAHLBETEILIGUNG_AUSWERTUNG_DELETE)
  public String deleteAndGoBack() {
    delete();
    return goBack(getParentViewId());
  }

  protected void addMessageDeleteSuccess() {
    addInfoMessage("entity.edit.action.delete.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnDeleteRendered() {
    return hasPermission(UseCasePermission.WAHLBETEILIGUNG_AUSWERTUNG_DELETE);
  }

  @Redirect
  @Override
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  @Override
  public boolean isBtnCancelRendered() {
    return true;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.WAHLBETEILIGUNG_AUSWERTUNG_EDIT)
  @Override
  public String save() {
    WahlbeteiligungAuswertung entity = getEntity();

    callSave(entity);

    addMessageSaveSuccess(entity);

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(WahlbeteiligungAuswertung entity) {
    edit.save(entity);
  }

  @Redirect
  @Override
  public String reset() {
    super.reset();
    WahlbeteiligungAuswertung entity = getEntity();
    resetStateAfterAction();
    setEntity(entity);
    return getViewId();
  }

  protected void addMessageSaveSuccess(WahlbeteiligungAuswertung entity) {
    addInfoMessage("entity.edit.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  @Override
  protected boolean isSavePermissionVorhanden() {
    return hasPermission(UseCasePermission.WAHLBETEILIGUNG_AUSWERTUNG_EDIT);
  }
  
  @Redirect
  public String edit(WahlbeteiligungAuswertung entity) {
    conversationStore.setEntityPK(entity.getPk());
    return getViewId();
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    conversationStore.close();
  }

  @de.ivu.elect.jee.faces.PreConditionCheck
  public void checkDoppelteBearbeitung() {
     entityViewStore.setEntity(getEntity());
  }

  @org.apache.deltaspike.core.api.scope.ViewAccessScoped
  public static class WahlbeteiligungAuswertungEditViewScopeStore extends  de.ivu.elect.presentation.edit.AbstractViewScopeStore<WahlbeteiligungAuswertung,   de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertungPK  > {

    private static final long serialVersionUID = 1L;
  }
}
